/* ******************************************************
Curso de Desenvolvimento de Aplicaes de 
Realidade Virtual
    Teste com Memria Remota Compartilhada
>>>>>>>    Cliente Leitor 
********************************************************/
#include <stdio.h>
#include <string.h>
#include <conio.h>


#include "RemoteMemory.h"

#define FLAG_DADOS_OK 111
#define FLAG_DADOS_VELHOS -111

/* ******************************************************
void GravaDadosNaMemoriaRemota()
    Esta rotina grava um vetor de 15 inteiros na 
    memria remota.
    Antes de iniciar a gravao, a rotina escreve um
    nmero negativo (-111) na posio 10 da memria
    para indicar ao clinte-leitor que os dados ainda 
    no esto disponveis.
 ****************************************************** */
void GravaDadosNaMemoriaRemota()
{
    int dado, vetor[15], i;
	printf ("Gravando Dados na Memria...\n");

	// Grava A constante FLAG_DADOS_VELHOS na posio 10 usando uma 
    // conexo TCP/IP, avisando que os dados gravados ainda no 
    // foram gravados.
    // O Cliente Leitor dever ficar lendo esta posio at que este valor 
    // seja alterado para FLAG_DADOS_OK
    
	dado = FLAG_DADOS_VELHOS;
	WriteOnRemoteMemoryIP (&dado, 10*sizeof(int),  sizeof(int));	
	
	// Grava um vetor de 15 nmeros a partir da posio 12 usando uma
    // conexo TCP/IP
	for (i=0;i<15;i++)
	   vetor[i] = (i+1)*10;
	WriteOnRemoteMemoryIP (&vetor[0], 12*sizeof(int),  15* sizeof(int));	

	// Grava a cosntante FLAG_DADOS_OK na posio 10 usando uma conexo TCP/IP,
	// avisando que a gravao do vetor foi concluda
	dado = FLAG_DADOS_OK;
	WriteOnRemoteMemoryIP (&dado, 10*sizeof(int),  sizeof(int));	
 }
 
/* ******************************************************
void LeDadosDaMemoriaRemota()
    Esta rotina l os dados de um vetor de inteiros 
    gravados na meria remota.
    Antes de iniciar a leitura a rotina testa se o 
    cliente-escritor j terminou a gravao dos dados.
    Este teste  feito verificando o valor da posio
    de memria 10
 ****************************************************** */
void LeDadosDaMemoriaRemota()
 {
     int i, dado, vetor[15];

 // Este lao fica esperando que o cliente-escritor 
 // grave uma flag avisando que os dados j esto 
 // disponveis   
     printf("Tentando ler");
     do
     {
        ReadFromRemoteMemoryIP (&dado, 10*sizeof(int), sizeof(int));
        printf(".");
     } while (dado != FLAG_DADOS_OK);

     printf("Dados disponveis !!\n");
     printf("\nDados Lidos:\n");

     // L o vetor de 15 nmeros a partir da posio 12 usando uma 
     // conexo TCP/IP
     ReadFromRemoteMemoryIP (&vetor[0], 12*sizeof(int),  15* sizeof(int));	
     
     for (i=0;i<15;i++)
	   printf("[%d]= %d\n", i, vetor[i]); 
 
 }
 
/* *******************************************************/
int  main ( int argc, char** argv ) 
{    
	int result;
	int opcao;
	char serverIP[30] = "127.0.0.1";  // Nro IP do servidor
	unsigned int port = 1000;  // porta de conexo com o servidor
	
	
	result = ConnectToRemoteMemory ( serverIP, port );
	if ( !result ) {  
		printf ( "Unable to connect to Memory Server at %s.\n", serverIP );
		printf ( "Pressione uma tecla para encerrar.");
		getchar();
		return 0;     
	}
	printf ("Conexo bem sucedida !\n"); 	
	
    printf("Este programa  um Escritor (1) ou Leitor (2) ? ");
	scanf("%d",&opcao); //= getchar();
	
	switch(opcao)
	{
	   case 1: // Escritor
	           GravaDadosNaMemoriaRemota();
	           break;
	   case 2: // Leitor
	           LeDadosDaMemoriaRemota();
	           break;
	}
		
	printf ("Pressione uma tecla para encerrar");
	while (!kbhit()){};
	return 1; 
	
}

     
